From e7c603e871bca4345f2da73e39de6ffd786ffc13 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Mon, 27 Feb 2012 09:36:14 -0600
Subject: [PATCH] Refactored NameValuePairs.

The NameValuePairs class has been modified to extend the Linked-
HashMap which preserves the order of elements as in the original
code. Some methods are renamed to match Java Map interface. The
NameValuePair class is no longer needed and has been removed.

Ticket #78
---
 .../ca/src/com/netscape/ca/CMSCRLExtensions.java   |   23 ++--
 .../ca/src/com/netscape/ca/CRLIssuingPoint.java    |    7 +-
 pki/base/common/src/CMakeLists.txt                 |    1 -
 .../com/netscape/certsrv/common/NameValuePair.java |   68 --------
 .../netscape/certsrv/common/NameValuePairs.java    |  121 +--------------
 .../cms/crl/CMSAuthInfoAccessExtension.java        |   14 +-
 .../cms/crl/CMSCertificateIssuerExtension.java     |   14 +-
 .../netscape/cms/crl/CMSFreshestCRLExtension.java  |   10 +-
 .../cms/crl/CMSHoldInstructionExtension.java       |    2 +-
 .../cms/crl/CMSIssuerAlternativeNameExtension.java |   14 +-
 .../crl/CMSIssuingDistributionPointExtension.java  |   16 +-
 .../src/com/netscape/cms/logging/LogFile.java      |    2 +-
 .../com/netscape/cms/logging/RollingLogFile.java   |    2 +-
 .../common/src/com/netscape/cms/ocsp/DefStore.java |   15 +-
 .../src/com/netscape/cms/ocsp/LDAPStore.java       |   29 ++--
 .../netscape/cms/profile/common/BasicProfile.java  |   18 +--
 .../cms/profile/def/AuthInfoAccessExtDefault.java  |   32 ++--
 .../def/CRLDistributionPointsExtDefault.java       |   60 ++++----
 .../netscape/cms/profile/def/EnrollDefault.java    |   10 +-
 .../cms/profile/def/FreshestCRLExtDefault.java     |   48 +++---
 .../cms/profile/def/NameConstraintsExtDefault.java |   24 ++--
 .../cms/profile/def/PolicyMappingsExtDefault.java  |   24 ++--
 .../def/SubjectDirAttributesExtDefault.java        |   25 ++--
 .../profile/def/SubjectInfoAccessExtDefault.java   |   28 ++--
 .../cms/servlet/admin/ACLAdminServlet.java         |   12 +-
 .../netscape/cms/servlet/admin/AdminServlet.java   |   22 ++--
 .../cms/servlet/admin/AuthAdminServlet.java        |   33 ++---
 .../netscape/cms/servlet/admin/CAAdminServlet.java |   50 +++---
 .../cms/servlet/admin/CMSAdminServlet.java         |   78 +++++-----
 .../cms/servlet/admin/JobsAdminServlet.java        |   33 ++---
 .../cms/servlet/admin/KRAAdminServlet.java         |    2 +-
 .../cms/servlet/admin/LogAdminServlet.java         |   31 ++--
 .../cms/servlet/admin/OCSPAdminServlet.java        |    8 +-
 .../cms/servlet/admin/PolicyAdminServlet.java      |   16 +-
 .../cms/servlet/admin/ProfileAdminServlet.java     |   44 +++---
 .../cms/servlet/admin/PublisherAdminServlet.java   |  161 ++++++++++----------
 .../netscape/cms/servlet/admin/RAAdminServlet.java |   10 +-
 .../cms/servlet/admin/RegistryAdminServlet.java    |    6 +-
 .../cms/servlet/admin/UsrGrpAdminServlet.java      |   26 ++--
 .../netscape/cmscore/security/JssSubsystem.java    |   35 ++---
 pki/base/console/src/CMakeLists.txt                |    1 -
 .../com/netscape/admin/certsrv/CMSCAUILoader.java  |    4 +-
 .../netscape/admin/certsrv/CMSKernelUILoader.java  |    3 +-
 .../com/netscape/admin/certsrv/CMSServerInfo.java  |   11 +-
 .../com/netscape/admin/certsrv/CMSUIFramework.java |    9 +-
 .../netscape/admin/certsrv/config/ACIDialog.java   |   12 +-
 .../admin/certsrv/config/ACLEditDialog.java        |   16 +--
 .../netscape/admin/certsrv/config/ACLImplTab.java  |    7 +-
 .../netscape/admin/certsrv/config/ACLPanel.java    |    7 +-
 .../netscape/admin/certsrv/config/CACertsTab.java  |   34 ++---
 .../admin/certsrv/config/CMSAccessLogPanel.java    |   65 ++++----
 .../admin/certsrv/config/CMSAuditLogPanel.java     |   65 ++++----
 .../admin/certsrv/config/CMSAutoRecovery.java      |   10 +-
 .../admin/certsrv/config/CMSBaseConfigDialog.java  |   43 +++---
 .../admin/certsrv/config/CMSBaseLDAPPanel.java     |  121 ++++++++--------
 .../certsrv/config/CMSCACertSettingPanel.java      |   16 +-
 .../admin/certsrv/config/CMSCAConnectorPanel.java  |   19 +--
 .../admin/certsrv/config/CMSCAGeneralPanel.java    |   47 +++---
 .../admin/certsrv/config/CMSCRLCachePanel.java     |   29 ++--
 .../admin/certsrv/config/CMSCRLFormatPanel.java    |   50 +++---
 .../admin/certsrv/config/CMSCRLIPPanel.java        |   16 +--
 .../admin/certsrv/config/CMSCRLSettingPanel.java   |   55 +++----
 .../admin/certsrv/config/CMSEAGeneralPanel.java    |   16 +--
 .../admin/certsrv/config/CMSEncryptionPanel.java   |   31 ++---
 .../admin/certsrv/config/CMSErrorLogPanel.java     |   37 ++---
 .../admin/certsrv/config/CMSKRAAutoPanel.java      |   13 +-
 .../admin/certsrv/config/CMSKRAPasswdPanel.java    |   15 +-
 .../admin/certsrv/config/CMSKRASchemePanel.java    |   15 +-
 .../admin/certsrv/config/CMSLDAPSettingPanel.java  |   42 +++---
 .../admin/certsrv/config/CMSNetworkPanel.java      |   39 +++---
 .../admin/certsrv/config/CMSOCSPGeneralPanel.java  |   17 +-
 .../admin/certsrv/config/CMSPasswordDialog.java    |    6 +-
 .../admin/certsrv/config/CMSPluginInstanceTab.java |   29 ++--
 .../admin/certsrv/config/CMSRACLMPanel.java        |   49 +++---
 .../admin/certsrv/config/CMSRAConnectorPanel.java  |   19 +--
 .../admin/certsrv/config/CMSRAGeneralPanel.java    |   15 +-
 .../admin/certsrv/config/CMSSMTPPanel.java         |   17 +-
 .../admin/certsrv/config/CMSSNMPPanel.java         |   53 +++----
 .../admin/certsrv/config/CMSSelfTestsPanel.java    |   16 +-
 .../certsrv/config/CMSUserCertSettingPanel.java    |   16 +-
 .../certsrv/config/CRLExtensionsRuleDataModel.java |    9 +-
 .../netscape/admin/certsrv/config/CRLIPEditor.java |   22 +--
 .../admin/certsrv/config/ConnectorEditor.java      |   51 +++----
 .../admin/certsrv/config/GeneralLogPanel.java      |   24 ++--
 .../admin/certsrv/config/JobsImplDataModel.java    |    5 +-
 .../netscape/admin/certsrv/config/JobsImplTab.java |   31 ++--
 .../admin/certsrv/config/JobsRuleDataModel.java    |    9 +-
 .../admin/certsrv/config/JobsSettingPanel.java     |   23 ++--
 .../admin/certsrv/config/KeyCreateDialog.java      |    7 +-
 .../admin/certsrv/config/LogImplDataModel.java     |    5 +-
 .../netscape/admin/certsrv/config/LogImplTab.java  |   25 ++--
 .../admin/certsrv/config/LogRuleDataModel.java     |    5 +-
 .../admin/certsrv/config/MNSchemeWizardInfo.java   |   13 +-
 .../admin/certsrv/config/MapperImplDataModel.java  |    5 +-
 .../admin/certsrv/config/MapperImplTab.java        |   25 ++--
 .../admin/certsrv/config/MapperRuleDataModel.java  |    5 +-
 .../certsrv/config/OCSPStoresInstanceTab.java      |    9 +-
 .../certsrv/config/OCSPStoresRuleDataModel.java    |    9 +-
 .../certsrv/config/PanelMapperConfigDialog.java    |   21 ++--
 .../certsrv/config/PluginSelectionDialog.java      |   11 +-
 .../admin/certsrv/config/PolicyImplDataModel.java  |    5 +-
 .../admin/certsrv/config/PolicyImplTab.java        |   25 ++--
 .../admin/certsrv/config/PolicyRuleDataModel.java  |    9 +-
 .../certsrv/config/PolicyRuleOrderDialog.java      |    5 +-
 .../admin/certsrv/config/ProfileConfigDialog.java  |   15 +-
 .../admin/certsrv/config/ProfileEditDialog.java    |   71 ++++-----
 .../admin/certsrv/config/ProfileImplDataModel.java |    7 +-
 .../admin/certsrv/config/ProfileImplTab.java       |   57 ++++----
 .../certsrv/config/ProfileNonPolicyNewDialog.java  |   23 ++--
 .../certsrv/config/ProfileNonPolicySelDialog.java  |    9 +-
 .../config/ProfilePluginSelectionDialog.java       |   12 +-
 .../certsrv/config/ProfilePolicyEditDialog.java    |   22 ++--
 .../certsrv/config/ProfilePolicyNewDialog.java     |   24 ++--
 .../config/ProfilePolicySelectionDialog.java       |    8 +-
 .../certsrv/config/ProfileRegisterDialog.java      |    8 +-
 .../admin/certsrv/config/ProfileRuleDataModel.java |   10 +-
 .../certsrv/config/PublisherImplDataModel.java     |    5 +-
 .../admin/certsrv/config/PublisherImplTab.java     |   23 ++--
 .../certsrv/config/PublisherRuleDataModel.java     |    5 +-
 .../admin/certsrv/config/RegisterDialog.java       |    5 +-
 .../admin/certsrv/config/RuleImplDataModel.java    |    5 +-
 .../netscape/admin/certsrv/config/RuleImplTab.java |   23 ++--
 .../admin/certsrv/config/RuleRuleDataModel.java    |    9 +-
 .../netscape/admin/certsrv/config/TKSKeysTab.java  |   23 +--
 .../admin/certsrv/config/UserCertsTab.java         |   21 +--
 .../config/install/WICertExtensionPage.java        |   68 ++++-----
 .../certsrv/config/install/WIGenKeyCertPage.java   |   12 +-
 .../config/install/WIGenKeyCertReqPage.java        |   16 +--
 .../admin/certsrv/connection/AdminConnection.java  |   50 +++---
 .../admin/certsrv/keycert/WCertDNPage.java         |   16 +-
 .../admin/certsrv/keycert/WCertExtensionPage.java  |   66 ++++----
 .../admin/certsrv/keycert/WCertTypePage.java       |    9 +-
 .../admin/certsrv/keycert/WDisplayCertPage.java    |   15 +-
 .../admin/certsrv/keycert/WExecute1Page.java       |    9 +-
 .../admin/certsrv/keycert/WExecutePage.java        |    7 +-
 .../admin/certsrv/keycert/WInstallOpPage.java      |    5 +-
 .../netscape/admin/certsrv/keycert/WIntroPage.java |    9 +-
 .../netscape/admin/certsrv/keycert/WKeyPage.java   |   34 ++---
 .../admin/certsrv/keycert/WPasteCertPage.java      |   11 +-
 .../admin/certsrv/keycert/WTokenLogonPage.java     |    9 +-
 .../certsrv/keycert/WWarningExecute1Page.java      |    6 +-
 .../certsrv/managecert/CertificateInfoDialog.java  |    8 +-
 .../admin/certsrv/managecert/ManageCertDialog.java |   17 +--
 .../certsrv/notification/RequestCompletePanel.java |   36 ++---
 .../certsrv/notification/RequestInQPanel.java      |   42 +++---
 .../certsrv/notification/RequestRevokedPanel.java  |   33 ++---
 .../admin/certsrv/status/LogInstancePanel.java     |   23 ++--
 .../netscape/admin/certsrv/status/StatusPanel.java |   17 +-
 .../netscape/admin/certsrv/ug/AuthBaseDialog.java  |   19 +--
 .../admin/certsrv/ug/AuthImplDataModel.java        |    9 +-
 .../com/netscape/admin/certsrv/ug/AuthImplTab.java |   31 ++--
 .../netscape/admin/certsrv/ug/AuthInstanceTab.java |   11 +-
 .../admin/certsrv/ug/AuthRuleDataModel.java        |    5 +-
 .../netscape/admin/certsrv/ug/CertDataModel.java   |    5 +-
 .../admin/certsrv/ug/CertManagementDialog.java     |   13 +-
 .../com/netscape/admin/certsrv/ug/GroupEditor.java |   23 ++--
 .../netscape/admin/certsrv/ug/GroupListDialog.java |    4 +-
 .../com/netscape/admin/certsrv/ug/GroupTab.java    |   10 +-
 .../netscape/admin/certsrv/ug/MemberDataModel.java |   19 +--
 .../com/netscape/admin/certsrv/ug/UserEditor.java  |   52 +++----
 .../netscape/admin/certsrv/ug/UserListDialog.java  |    6 +-
 .../src/com/netscape/admin/certsrv/ug/UserTab.java |    5 +-
 .../com/netscape/certsrv/common/NameValuePair.java |   56 -------
 .../netscape/certsrv/common/NameValuePairs.java    |  122 +++-------------
 164 files changed, 1638 insertions(+), 2272 deletions(-)
 delete mode 100644 pki/base/common/src/com/netscape/certsrv/common/NameValuePair.java
 delete mode 100644 pki/base/console/src/com/netscape/certsrv/common/NameValuePair.java

diff --git a/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java b/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java
index 8c59d42d80c4c38633ba0e8d246410b2c7fbfb3d..94693d69ada90fbc2d784f31d47c18f38cc124ad 100644
--- a/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java
+++ b/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java
@@ -49,7 +49,6 @@ import com.netscape.certsrv.ca.ICMSCRLExtensions;
 import com.netscape.certsrv.ca.ICRLIssuingPoint;
 import com.netscape.certsrv.ca.ICertificateAuthority;
 import com.netscape.certsrv.common.Constants;
-import com.netscape.certsrv.common.NameValuePair;
 import com.netscape.certsrv.common.NameValuePairs;
 import com.netscape.certsrv.logging.ILogger;
 import com.netscape.cms.crl.CMSIssuingDistributionPointExtension;
@@ -521,14 +520,14 @@ public class CMSCRLExtensions implements ICMSCRLExtensions {
              */
 
             if (mEnabledCRLExtensions.contains(id)) {
-                nvp.add(PROP_ENABLE, Constants.TRUE);
+                nvp.put(PROP_ENABLE, Constants.TRUE);
             } else {
-                nvp.add(PROP_ENABLE, Constants.FALSE);
+                nvp.put(PROP_ENABLE, Constants.FALSE);
             }
             if (mCriticalCRLExtensions.contains(id)) {
-                nvp.add(PROP_CRITICAL, Constants.TRUE);
+                nvp.put(PROP_CRITICAL, Constants.TRUE);
             } else {
-                nvp.add(PROP_CRITICAL, Constants.FALSE);
+                nvp.put(PROP_CRITICAL, Constants.FALSE);
             }
 
             if (mCRLExtensionClassNames.containsKey(id)) {
@@ -563,7 +562,7 @@ public class CMSCRLExtensions implements ICMSCRLExtensions {
                         String idName = name.substring(i + 1);
 
                         if (idName != null) {
-                            nvp.add(Constants.PR_CRLEXT_IMPL_NAME, idName);
+                            nvp.put(Constants.PR_CRLEXT_IMPL_NAME, idName);
                         }
                     }
                 }
@@ -574,17 +573,15 @@ public class CMSCRLExtensions implements ICMSCRLExtensions {
 
     public void setConfigParams(String id, NameValuePairs nvp, IConfigStore config) {
         ICertificateAuthority ca = (ICertificateAuthority) CMS.getSubsystem(CMS.SUBSYSTEM_CA);
-        String ipId = nvp.getValue("id");
+        String ipId = nvp.get("id");
 
         ICRLIssuingPoint ip = null;
         if (ipId != null && ca != null) {
             ip = ca.getCRLIssuingPoint(ipId);
         }
 
-        for (int i = 0; i < nvp.size(); i++) {
-            NameValuePair p = nvp.elementAt(i);
-            String name = p.getName();
-            String value = p.getValue();
+        for (String name : nvp.keySet()) {
+            String value = nvp.get(name);
 
             if (name.equals(PROP_ENABLE)) {
                 if (!(value.equals(Constants.TRUE) || value.equals(Constants.FALSE))) {
@@ -647,7 +644,7 @@ public class CMSCRLExtensions implements ICMSCRLExtensions {
                 if (value.equals(Constants.TRUE) && (issuingDistPointExtEnabled == true)) {
                     if (crlCACertsOnly == false) {
                         CMS.debug(" value = true and CRLCACertsOnly is already false.");
-                        crlIssuingPointPairs.add(Constants.PR_CA_CERTS_ONLY, Constants.TRUE);
+                        crlIssuingPointPairs.put(Constants.PR_CA_CERTS_ONLY, Constants.TRUE);
                         newValue = Constants.TRUE;
                         ip.updateConfig(crlIssuingPointPairs);
                         modifiedCRLConfig = true;
@@ -656,7 +653,7 @@ public class CMSCRLExtensions implements ICMSCRLExtensions {
 
                 //If the CRLCACertsOnly prop is true change it to false to sync.
                 if (value.equals(Constants.FALSE) && (issuingDistPointExtEnabled == true)) {
-                    crlIssuingPointPairs.add(Constants.PR_CA_CERTS_ONLY, Constants.FALSE);
+                    crlIssuingPointPairs.put(Constants.PR_CA_CERTS_ONLY, Constants.FALSE);
                     if (ip != null) {
                         ip.updateConfig(crlIssuingPointPairs);
                         newValue = Constants.FALSE;
diff --git a/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java b/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
index 1c89a29c8694847ee03ecb1f2964ad11578f04ff..01ef0532d7dab2dd6f71752197717ca10d121c99 100644
--- a/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
+++ b/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
@@ -58,7 +58,6 @@ import com.netscape.certsrv.ca.ICMSCRLExtensions;
 import com.netscape.certsrv.ca.ICRLIssuingPoint;
 import com.netscape.certsrv.ca.ICertificateAuthority;
 import com.netscape.certsrv.common.Constants;
-import com.netscape.certsrv.common.NameValuePair;
 import com.netscape.certsrv.common.NameValuePairs;
 import com.netscape.certsrv.dbs.EDBNotAvailException;
 import com.netscape.certsrv.dbs.IElementProcessor;
@@ -933,10 +932,8 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
             boolean noRestart = true;
             boolean modifiedSchedule = false;
 
-            for (int i = 0; i < params.size(); i++) {
-                NameValuePair p = params.elementAt(i);
-                String name = p.getName();
-                String value = p.getValue();
+            for (String name : params.keySet()) {
+                String value = params.get(name);
 
                 // -- Update Schema --
                 if (name.equals(Constants.PR_ENABLE_CRL)) {
diff --git a/pki/base/common/src/CMakeLists.txt b/pki/base/common/src/CMakeLists.txt
index 62d30740df830353f4a6d1ae795793d0d6a3b9b1..328809faf7440fc15abba6af3331e97a7e8d72eb 100644
--- a/pki/base/common/src/CMakeLists.txt
+++ b/pki/base/common/src/CMakeLists.txt
@@ -90,7 +90,6 @@ set(pki-certsrv_java_SRCS
     com/netscape/certsrv/common/ScopeDef.java
     com/netscape/certsrv/common/PrefixDef.java
     com/netscape/certsrv/common/ConfigConstants.java
-    com/netscape/certsrv/common/NameValuePair.java
     com/netscape/certsrv/common/OpDef.java
     com/netscape/certsrv/common/Constants.java
     com/netscape/certsrv/usrgrp/EUsrGrpException.java
diff --git a/pki/base/common/src/com/netscape/certsrv/common/NameValuePairs.java b/pki/base/common/src/com/netscape/certsrv/common/NameValuePairs.java
index 61d3cad62342a81feb0b699af3769efb9af4f3d3..0999db7bc5fb84e33736b6f1afc4c3fa85e874d1 100644
--- a/pki/base/common/src/com/netscape/certsrv/common/NameValuePairs.java
+++ b/pki/base/common/src/com/netscape/certsrv/common/NameValuePairs.java
@@ -17,10 +17,8 @@
 // --- END COPYRIGHT BLOCK ---
 package com.netscape.certsrv.common;
 
-import java.util.Enumeration;
-import java.util.Hashtable;
+import java.util.LinkedHashMap;
 import java.util.StringTokenizer;
-import java.util.Vector;
 
 /**
  * A class represents an ordered list of name
@@ -28,13 +26,9 @@ import java.util.Vector;
  * 
  * @version $Revision$, $Date$
  */
-public class NameValuePairs {
+public class NameValuePairs extends LinkedHashMap<String, String> {
 
-    private Vector<NameValuePair> mPairs = new Vector<NameValuePair>();
-
-    // an index to speed up searching
-    // The key is the name.  The element is the NameValuePair.
-    private Hashtable<String, NameValuePair> index = new Hashtable<String, NameValuePair>();
+    private static final long serialVersionUID = 1494507857048437440L;
 
     /**
      * Constructs name value pairs.
@@ -43,97 +37,6 @@ public class NameValuePairs {
     }
 
     /**
-     * Adds a name value pair into this set.
-     * if the name already exist, the value will
-     * be replaced.
-     * 
-     * @param name name
-     * @param value value
-     */
-    public void add(String name, String value) {
-        NameValuePair pair = getPair(name);
-
-        if (pair == null) {
-            pair = new NameValuePair(name, value);
-            mPairs.addElement(pair);
-            index.put(name, pair);
-        } else {
-            pair.setValue(value);
-        }
-    }
-
-    /**
-     * Retrieves name value pair from this set.
-     * 
-     * @param name name
-     * @return name value pair
-     */
-    public NameValuePair getPair(String name) {
-        return (NameValuePair) index.get(name);
-    }
-
-    /**
-     * Returns number of pairs in this set.
-     * 
-     * @return size
-     */
-    public int size() {
-        return mPairs.size();
-    }
-
-    /**
-     * Retrieves name value pairs in specific position.
-     * 
-     * @param pos position of the value
-     * @return name value pair
-     */
-    public NameValuePair elementAt(int pos) {
-        return (NameValuePair) mPairs.elementAt(pos);
-    }
-
-    /**
-     * Removes all name value pairs in this set.
-     */
-    public void removeAllPairs() {
-        mPairs.removeAllElements();
-        index.clear();
-    }
-
-    /**
-     * Retrieves value of the name value pairs that matches
-     * the given name.
-     * 
-     * @param name name
-     * @return value
-     */
-    public String getValue(String name) {
-        NameValuePair p = getPair(name);
-
-        if (p != null) {
-            return p.getValue();
-        }
-        return null;
-    }
-
-    /**
-     * Retrieves a list of names.
-     * 
-     * @return a list of names
-     */
-    public Enumeration<String> getNames() {
-        Vector<String> v = new Vector<String>();
-        int size = mPairs.size();
-
-        for (int i = 0; i < size; i++) {
-            NameValuePair p = (NameValuePair) mPairs.elementAt(i);
-
-            v.addElement(p.getName());
-        }
-        //System.out.println("getNames: "+v.size());
-        return v.elements();
-    }
-
-    /**
      * Show the content of this name value container as
      * string representation.
      * 
@@ -142,12 +45,13 @@ public class NameValuePairs {
     public String toString() {
         StringBuffer buf = new StringBuffer();
 
-        for (int i = 0; i < mPairs.size(); i++) {
-            NameValuePair p = (NameValuePair) mPairs.elementAt(i);
+        for (String name : keySet()) {
+            String value = get(name);
 
-            buf.append(p.getName() + "=" + p.getValue());
+            buf.append(name + "=" + value);
             buf.append("\n");
         }
+
         return buf.toString();
     }
 
@@ -171,17 +75,8 @@ public class NameValuePairs {
             String n = t.substring(0, i);
             String v = t.substring(i + 1);
 
-            nvp.add(n, v);
+            nvp.put(n, v);
         }
         return true;
     }
-
-    /**
-     * Returns a list of name value pair object.
-     * 
-     * @return name value objects
-     */
-    public Enumeration<NameValuePair> elements() {
-        return mPairs.elements();
-    }
 }
diff --git a/pki/base/common/src/com/netscape/cms/crl/CMSAuthInfoAccessExtension.java b/pki/base/common/src/com/netscape/cms/crl/CMSAuthInfoAccessExtension.java
index d070cc6fd513b1ab0da31ab71c2633fd93a48a0a..d4cef014871980527ffc33d4a4218cfadb5c8a86 100644
--- a/pki/base/common/src/com/netscape/cms/crl/CMSAuthInfoAccessExtension.java
+++ b/pki/base/common/src/com/netscape/cms/crl/CMSAuthInfoAccessExtension.java
@@ -159,7 +159,7 @@ public class CMSAuthInfoAccessExtension
         } catch (EBaseException e) {
             log(ILogger.LL_FAILURE, CMS.getLogMessage("CRL_CREATE_AIA_INVALID_NUM_ADS", e.toString()));
         }
-        nvp.add(PROP_NUM_ADS, String.valueOf(numberOfAccessDescriptions));
+        nvp.put(PROP_NUM_ADS, String.valueOf(numberOfAccessDescriptions));
 
         for (int i = 0; i < numberOfAccessDescriptions; i++) {
             String accessMethod = null;
@@ -175,9 +175,9 @@ public class CMSAuthInfoAccessExtension
             }
 
             if (accessMethod != null && accessMethod.length() > 0) {
-                nvp.add(PROP_ACCESS_METHOD + i, accessMethod);
+                nvp.put(PROP_ACCESS_METHOD + i, accessMethod);
             } else {
-                nvp.add(PROP_ACCESS_METHOD + i, PROP_ACCESS_METHOD_CAISSUERS);
+                nvp.put(PROP_ACCESS_METHOD + i, PROP_ACCESS_METHOD_CAISSUERS);
             }
 
             try {
@@ -189,9 +189,9 @@ public class CMSAuthInfoAccessExtension
             }
 
             if (accessLocationType != null && accessLocationType.length() > 0) {
-                nvp.add(PROP_ACCESS_LOCATION_TYPE + i, accessLocationType);
+                nvp.put(PROP_ACCESS_LOCATION_TYPE + i, accessLocationType);
             } else {
-                nvp.add(PROP_ACCESS_LOCATION_TYPE + i, PROP_URINAME);
+                nvp.put(PROP_ACCESS_LOCATION_TYPE + i, PROP_URINAME);
             }
 
             try {
@@ -203,14 +203,14 @@ public class CMSAuthInfoAccessExtension
             }
 
             if (accessLocation != null && accessLocation.length() > 0) {
-                nvp.add(PROP_ACCESS_LOCATION + i, accessLocation);
+                nvp.put(PROP_ACCESS_LOCATION + i, accessLocation);
             } else {
                 String hostname = CMS.getEENonSSLHost();
                 String port = CMS.getEENonSSLPort();
                 if (hostname != null && port != null) {
                     accessLocation = "http://" + hostname + ":" + port + "/ca/ee/ca/getCAChain?op=downloadBIN";
                 }
-                nvp.add(PROP_ACCESS_LOCATION + i, accessLocation);
+                nvp.put(PROP_ACCESS_LOCATION + i, accessLocation);
             }
         }
     }
diff --git a/pki/base/common/src/com/netscape/cms/crl/CMSCertificateIssuerExtension.java b/pki/base/common/src/com/netscape/cms/crl/CMSCertificateIssuerExtension.java
index 67f4736c7a35305f45fb9b7427d30d3c86b18912..b0bf20856089122b455599b2300c69ea2cfabc20 100644
--- a/pki/base/common/src/com/netscape/cms/crl/CMSCertificateIssuerExtension.java
+++ b/pki/base/common/src/com/netscape/cms/crl/CMSCertificateIssuerExtension.java
@@ -149,7 +149,7 @@ public class CMSCertificateIssuerExtension
         } catch (EBaseException e) {
             log(ILogger.LL_FAILURE, CMS.getLogMessage("CRL_CREATE_INVALID_NUM_NAMES", e.toString()));
         }
-        nvp.add("numNames", String.valueOf(numNames));
+        nvp.put("numNames", String.valueOf(numNames));
 
         for (int i = 0; i < numNames; i++) {
             String nameType = null;
@@ -164,9 +164,9 @@ public class CMSCertificateIssuerExtension
             }
 
             if (nameType != null && nameType.length() > 0) {
-                nvp.add("nameType" + i, nameType);
+                nvp.put("nameType" + i, nameType);
             } else {
-                nvp.add("nameType" + i, "");
+                nvp.put("nameType" + i, "");
             }
 
             String name = null;
@@ -181,16 +181,16 @@ public class CMSCertificateIssuerExtension
             }
 
             if (name != null && name.length() > 0) {
-                nvp.add("name" + i, name);
+                nvp.put("name" + i, name);
             } else {
-                nvp.add("name" + i, "");
+                nvp.put("name" + i, "");
             }
         }
 
         if (numNames < 3) {
             for (int i = numNames; i < 3; i++) {
-                nvp.add("nameType" + i, "");
-                nvp.add("name" + i, "");
+                nvp.put("nameType" + i, "");
+                nvp.put("name" + i, "");
             }
         }
     }
diff --git a/pki/base/common/src/com/netscape/cms/crl/CMSFreshestCRLExtension.java b/pki/base/common/src/com/netscape/cms/crl/CMSFreshestCRLExtension.java
index edb6494aff9ac78911dd8ba81e73fa3404e31b9f..72dbe55027b5499e77f03033481150d86a7a039a 100644
--- a/pki/base/common/src/com/netscape/cms/crl/CMSFreshestCRLExtension.java
+++ b/pki/base/common/src/com/netscape/cms/crl/CMSFreshestCRLExtension.java
@@ -157,7 +157,7 @@ public class CMSFreshestCRLExtension
             log(ILogger.LL_FAILURE, "Invalid numPoints property for CRL " +
                     "Freshest CRL extension - " + e);
         }
-        nvp.add(PROP_NUM_POINTS, String.valueOf(numPoints));
+        nvp.put(PROP_NUM_POINTS, String.valueOf(numPoints));
 
         for (int i = 0; i < numPoints; i++) {
             String pointType = null;
@@ -171,9 +171,9 @@ public class CMSFreshestCRLExtension
             }
 
             if (pointType != null && pointType.length() > 0) {
-                nvp.add(PROP_POINTTYPE + i, pointType);
+                nvp.put(PROP_POINTTYPE + i, pointType);
             } else {
-                nvp.add(PROP_POINTTYPE + i, "");
+                nvp.put(PROP_POINTTYPE + i, "");
             }
 
             String pointName = null;
@@ -187,9 +187,9 @@ public class CMSFreshestCRLExtension
             }
 
             if (pointName != null && pointName.length() > 0) {
-                nvp.add(PROP_POINTNAME + i, pointName);
+                nvp.put(PROP_POINTNAME + i, pointName);
             } else {
-                nvp.add(PROP_POINTNAME + i, "");
+                nvp.put(PROP_POINTNAME + i, "");
             }
         }
     }
diff --git a/pki/base/common/src/com/netscape/cms/crl/CMSHoldInstructionExtension.java b/pki/base/common/src/com/netscape/cms/crl/CMSHoldInstructionExtension.java
index df8d058ce587fed0ab5b943620d0c117a3b2be46..4023e3b2ff00b1c11041725e0e5d30c83880057a 100644
--- a/pki/base/common/src/com/netscape/cms/crl/CMSHoldInstructionExtension.java
+++ b/pki/base/common/src/com/netscape/cms/crl/CMSHoldInstructionExtension.java
@@ -123,7 +123,7 @@ public class CMSHoldInstructionExtension
         } else {
             instruction = PROP_INSTR_NONE;
         }
-        nvp.add(PROP_INSTR, instruction);
+        nvp.put(PROP_INSTR, instruction);
     }
 
     public String[] getExtendedPluginInfo(Locale locale) {
diff --git a/pki/base/common/src/com/netscape/cms/crl/CMSIssuerAlternativeNameExtension.java b/pki/base/common/src/com/netscape/cms/crl/CMSIssuerAlternativeNameExtension.java
index ee656a1999cc30a04115da99a7e7d1ad995022a9..64252a0b9ae530ba76238b9efa502265ab47979a 100644
--- a/pki/base/common/src/com/netscape/cms/crl/CMSIssuerAlternativeNameExtension.java
+++ b/pki/base/common/src/com/netscape/cms/crl/CMSIssuerAlternativeNameExtension.java
@@ -200,7 +200,7 @@ public class CMSIssuerAlternativeNameExtension
             log(ILogger.LL_FAILURE, "Invalid numNames property for CRL " +
                     "IssuerAlternativeName extension - " + e);
         }
-        nvp.add("numNames", String.valueOf(numNames));
+        nvp.put("numNames", String.valueOf(numNames));
 
         for (int i = 0; i < numNames; i++) {
             String nameType = null;
@@ -216,9 +216,9 @@ public class CMSIssuerAlternativeNameExtension
             }
 
             if (nameType != null && nameType.length() > 0) {
-                nvp.add("nameType" + i, nameType);
+                nvp.put("nameType" + i, nameType);
             } else {
-                nvp.add("nameType" + i, "");
+                nvp.put("nameType" + i, "");
             }
 
             String name = null;
@@ -234,16 +234,16 @@ public class CMSIssuerAlternativeNameExtension
             }
 
             if (name != null && name.length() > 0) {
-                nvp.add("name" + i, name);
+                nvp.put("name" + i, name);
             } else {
-                nvp.add("name" + i, "");
+                nvp.put("name" + i, "");
             }
         }
 
         if (numNames < 3) {
             for (int i = numNames; i < 3; i++) {
-                nvp.add("nameType" + i, "");
-                nvp.add("name" + i, "");
+                nvp.put("nameType" + i, "");
+                nvp.put("name" + i, "");
             }
         }
     }
